import 'reflect-metadata';
import * as Router from 'koa-router';
import { IHandlerOptions } from './declarations';
import { OverrideRule } from './overrides';
import { ParamsOptions } from './params';
export declare function Config(options: Router.IRouterOptions): (cls: any) => void;
export declare function Handler(options?: IHandlerOptions): PropertyDecorator;
export declare function Get(path: string, options?: IHandlerOptions): PropertyDecorator;
export declare function Post(path: string, options?: IHandlerOptions): PropertyDecorator;
export declare function Put(path: string, options?: IHandlerOptions): PropertyDecorator;
export declare function Delete(path: string, options?: IHandlerOptions): PropertyDecorator;
export declare function Middleware(middlewares: Router.IMiddleware | Router.IMiddleware[]): ClassDecorator & PropertyDecorator;
export declare function If(predictor: (ctx: Router.IRouterContext) => boolean | Promise<boolean>, ifClause: Router.IMiddleware, elseClause?: Router.IMiddleware): ClassDecorator & PropertyDecorator;
export declare function When(predictor: (ctx: Router.IRouterContext) => boolean | Promise<boolean>, whenClause: Router.IMiddleware): ClassDecorator & PropertyDecorator;
export declare const Overrides: (...rules: OverrideRule[]) => ClassDecorator & PropertyDecorator;
export declare const Params: (options: ParamsOptions) => ClassDecorator & PropertyDecorator;
